
pro bc_sn, mag, time, zerop=zerop, xbin=xbin, ybin=ybin, seeing=seeing, $
          sky=sky

   if N_PARAMS() LT 2 then begin
     print, "Syntax: mike_sn, mag, time, zerop=zerop, "
     print, "       xbin=xbin, ybin=ybin, seeing=seeing, sky=sky"
     print, "  sky : sky is skybright per arcsecond per seeing disc"
     return
   endif
      
   if NOT keyword_set(zerop) then zerop=18.0  ; 1 cts/s/Ang
   if NOT keyword_set(seeing) then seeing=1.0
   if NOT keyword_set(xbin) then xbin = 1.0 
   if NOT keyword_set(ybin) then ybin = 1.0 
   if NOT keyword_set(sky) then  sky = 22.0 

   wave = 4000.0
   xvel = (0.8/wave) * 3e5 * xbin
   ; calculate
   zerob = zerop + 2.5 * alog10(0.8 * xbin)
   sci = 10^(0.4*(zerob - mag)) * time
   skypix = 10^(0.4*(zerob - sky)) * time / 4 * ybin
   
   ccd_pix = 16.0
   totalcts = sci + (skypix + ccd_pix) * 6 / seeing / ybin

   sn_xvel = sci / sqrt(totalcts)
   sn_70   = sn_xvel * sqrt(70.0/xvel)

   print, "Estimated S/N for Blue side of MIKE :", sci
   print, "----", xvel, " -------------------", 70, "km/s" 
   print, "   ", sn_xvel, "                      ", sn_70
   print, "Noise contribution from  Source :", sci / totalcts
   print, "                         Sky:    ", skypix * 7.5/seeing/ybin/totalcts
   print, "                         ccd_pix:", ccd_pix* 7.5/seeing/ybin/totalcts


   return
end
