pro bcproc, filename, image, invvar, hdr, bias=bias, flat=flat

    tt = mrdfits(filename,0,hdr)

    if (size(tt))[0] NE 2 then return

    ncol = (size(tt))[1]
    nrow = (size(tt))[2]

    readoutvariance = 0.0

    if ncol GT 2026 then begin
      nover = lindgen(ncol - 2048L) + 2048L
      ncol = 2048L
      djs_iterstat, tt[nover,*], sigma=readoutnoise
      readoutvariance = readoutnoise^2
      overs = replicate(1,ncol) # djs_median(tt[nover,*],1) 
      image = tt[0:ncol-1,*] - overs
    endif else image = tt

    invvar = 1.0/(abs(image) + (image EQ 0) + readoutvariance)

    bias_image = 0
    if keyword_set(bias) then begin
      if size(bias,/tname) EQ 'STRING' then begin
         if findfile(bias) NE '' then bias_image = mrdfits(bias) 
      endif else bias_image = bias

      if n_elements(bias_image) EQ n_elements(image) then $
         image = image - biasimage
    endif

    flat_image = 0
    if keyword_set(flat) then begin
      if size(flat,/tname) EQ 'STRING' then begin
         if findfile(flat) NE '' then flat_image = mrdfits(flat) 
      endif else flat_image = flat 

      if n_elements(flat_image) EQ n_elements(image) then $
         divideflat, image, flat_image, invvar=invvar, minval=0.3
    endif

    return
end
