
pro mike_sn, mag, time, zerop=zerop, xbin=xbin, ybin=ybin, seeing=seeing, $
          sky=sky,wave=wave

   if N_PARAMS() LT 2 then begin
     print, "Syntax: mike_sn, mag, time, zerop=zerop, "
     print, "       xbin=xbin, ybin=ybin, seeing=seeing, sky=sky"
     print, "  sky : sky is skybright per arcsecond per seeing disc"
     return
   endif
      
   if NOT keyword_set(zerop) then zerop=18.6  ; 1 cts/s/Ang
   if NOT keyword_set(seeing) then seeing=1.0
   if NOT keyword_set(xbin) then xbin = 1.0 
   if NOT keyword_set(ybin) then ybin = 1.0 
   if NOT keyword_set(wave) then  wave = 4000.0
  
   if wave LT 4600.  then begin
     xvel = 1.6 * xbin
     if NOT keyword_set(sky) then  sky = 22.0 
   endif else begin
     xvel = 2.25 * xbin
     if NOT keyword_set(sky) then  sky = 20.0 
   endelse
 

   ; calculate
   zerob = zerop + 2.5 * alog10(0.021 * xbin)
   sci = 10^(0.4*(zerob - mag)) * time
   skypix = 10^(0.4*(zerob - sky)) * time / 7.5 * ybin
   
   ccd_pix = 10.0
   totalcts = sci + (skypix + ccd_pix) * 7.5 / seeing / ybin

   sn_xvel = sci / sqrt(totalcts)
   sn_70   = sn_xvel * sqrt(70.0/xvel)

   print, "Estimated S/N for Blue side of MIKE :", sci
   print, "----", xvel, " -------------------", 70, "km/s" 
   print, "   ", sn_xvel, "                      ", sn_70
   print, "Noise contribution from  Source :", sci / totalcts
   print, "                         Sky:    ", skypix * 7.5/seeing/ybin/totalcts
   print, "                         ccd_pix:", ccd_pix* 7.5/seeing/ybin/totalcts


   return
end
