function xproc, image, xsetfile, slitfinal=slitfinal, filename=filename, hdr=hdr

    if keyword_set(filename) then mproc, filename, image, hdr=hdr

    if n_elements(image) LT 2 then return, 0
    ocol = (size(image))[1]
    orow = (size(image))[2]
    if NOT keyword_set(slitfinal) then slitfinal=2*long(29L * ocol / 2048) + 1

     commentline = strarr(1)
     distortord = 0L
     ncoeff     = 0L
     nmatches   = 0L
     openr, ilun, xsetfile, /get_lun
     readf, ilun, commentline
     readf, ilun, distortord
     distortion = fltarr(distortord)
     readf, ilun, distortion

     readf, ilun, commentline
     readf, ilun, ncoeff, nmatches
     coeff = fltarr(ncoeff, nmatches)
     readf, ilun, coeff
     free_lun, ilun
    
;    distortion = mrdfits(xsetfile, 0)
;    tset = mrdfits(xsetfile, 1)

    tset       = { func : 'legendre', xmin : 0.0, xmax: float(orow)-1.0, $
                    coeff : coeff }
    traceset2xy, tset, ytrace, tracefit

    dpix = poly(tracefit[orow/2,*],distortion)
    tracefit = tracefit * ocol
     
    ntrace = (size(tracefit))[2]
    recimage = fltarr(orow, slitfinal+2, ntrace)

    x= findgen(slitfinal) - (slitfinal-1)/2

;
;   smooth fit to slitmeas
;

    for i=0,ntrace -1 do begin
      radius = dpix[i]/2.
      tempfit = replicate(1.0,slitfinal) ## tracefit[*,i]  + $
                   (x ## replicate(1,orow)) * 2 * radius

      recimage[*,2:slitfinal+1,i] = extract_boxcar(image, tempfit,radius=radius)
      recimage[*,0,i] = i+1
      recimage[*,1,i] = median(recimage[*,2:slitfinal+1,i])
    endfor

    return, reform(recimage, orow, (slitfinal+2)*ntrace)
end
